program dict; //  
{$APPTYPE    CONSOLE}
uses Sysutils, Classes;

type
  TInt  = class(TObject)
    f: integer;
    constructor Create( v:integer );
    procedure   Incr;
  end;

  TDict = class(TStringList)
    procedure   LoadFromFile(const FileName: string); override;
    function    Incr ( const s: string ):boolean; //   ,   
    function    Incr2( const s: string ):boolean; //   ,  
    procedure   SaveToFileF(const FileName: string; fr0: integer);
  end;
//---------------------------------------------
var ReadWordBuf, lastword: string;
    NReadLines: integer;
    is866     : boolean; //     866 ?
//---------------------------------------------
Function   RusUpp( ch: char ): char; // ->     
var cb: byte;
begin
  cb := ord(ch);
  RusUpp := ' ';
  //if ch='-' then rusupp:='-';
  if is866 then begin
    if (cb >= 128) and (cb<=159) then RusUpp := char(cb+64);
    if (cb >= 160) and (cb<=175) then RusUpp := char(cb+32);
    if (cb >= 224) and (cb<=239) then RusUpp := char(cb-16);
  end else begin
    if ( ch>='')and ( ch<='')then RusUpp:=ch;
    if ( ch>='')and ( ch<='')then RusUpp:=char( ord( ch)-ord('')+ord(''));
  end;
end;
//---------------------------------------------
procedure Help(const s: string );
begin
  WriteLn('Work with dictionaries.');
  WriteLn('dict 0          - clear frequences in RUS_WORD.ORG and RUS_NEW.ORG');
  WriteLn('dict FILEMASKS  - increase frequences if RUS_WORD.ORG and RUS_NEW.ORG');
  WriteLn('                  from files FILEMASK');
  WriteLn('!!Files of length < 256 ignored');
  WriteLn;
  WriteLn( s );
  Halt;
end;
//----   866 ?
function  Check866( fn: string ): boolean;
const bsize = 4096;
var ft: file;
    buf: array[1..bsize] of byte;
    fre: array[128..255] of integer; //  
    i, NumRead: integer;
    pd, pdn, pw, pwn : integer;
  // - - -   
  function su( i1, i2: integer ): integer;
  var i,s: integer;
  begin
     s := 0;
     for i:=i1 to i2 do s:=s+fre[i];
     su := s;
  end;
  //   Check866
begin
  AssignFile( ft, fn ); Reset(ft,1);
  BlockRead( ft, buf, bsize, NumRead);
  for i:=128 to 255 do fre[i] := 0;
  for i:=1 to NumRead do if buf[i]>=128 then inc(fre[buf[i]]);
  CloseFile( ft );
  pd := su( 128, 175 ) + su( 224, 239 );
  pdn:= su( 176, 223 ) + su( 240, 255 );
  pw := su( 192, 255 );
  pwn:= su( 128, 191 );
  if pd*pwn > pw*pdn then Check866 := True else Check866 := False;
end;
//---------------------------------------------
constructor TInt.Create( v:integer );
begin
  f:=v;
end;
//---------------------------------------------
procedure TInt.Incr; begin Inc(f); end;
//---------------------------------------------
procedure   TDict.LoadFromFile(const FileName: string);
var i, p, fr, code, cnt:integer;
    s, sb, slast:string;
    addi: integer;
    ft : TextFile;
begin
  Sorted     := True;
  Duplicates := dupIgnore;
  if not FileExists(FileName) then Exit;

  // inherited LoadFromFile( FileName );  -   
  AssignFile( ft, FileName); Reset(ft); cnt:=0;
  while not eof(ft) do begin
    ReadLn( ft, s); s:=Trim(s); inc(cnt);
    if (cnt mod 1000) = 0 then Write( cnt:9, #13 );
    if length(s)<4 then continue;
    p := pos( ' ', s );
    if p>0 then begin                                 //  
      if p < 5 then continue;                         //   4   
      val( copy(s, p+1, 40), fr, code );
      s := copy( s, 1, p-1 );
      for i:= 1 to p-1 do s[i] := RusUpp( s[i] );
      i:=Add( copy( s, 1, 16) );
      if code =0 then objects[i] := TInt.Create(fr);  //     - 
    end else begin
      for i:= 1 to length(s) do s[i] := RusUpp( s[i] );
      Add( copy( s, 1, 16) );
    end;
  end;
  CloseFile(ft);

  //.     >3
  Sorted := True;
  i:=0; addi:=0; slast := '';
  while i<count do begin
    if (i mod 10000)=0 then write( 'i=', i:6, ' size=', count:6, ' news=', addi:6, #13 );
    s := Strings[i];
    if slast <> copy(s,1,Length(s)-1) then begin
      for p:=4 to Length(s)-1 do begin
        sb := copy(s,1,p);
        if not Find( sb, code) then begin
          AddObject( sb, TInt.Create(0));
          inc(addi);
        end;
      end;
    end;
    slast := s;
    inc(i);
  end;
end;
//---------------------------------------------
procedure   TDict.SaveToFileF(const FileName: string; fr0: integer);
var ft: TextFile;
    i, fr: integer;
    s: string[16];
begin
{$I-}
  AssignFile( ft, FileName); Rewrite(ft); if IOResult <> 0 then Exit;
{$I+}
  for i:= 0 to count-1 do begin
    fr := TInt(objects[i]).f;
    if fr>=fr0 then begin
      s := strings[i]+'                 ';
      WriteLn( ft, s, TInt(objects[i]).f:9);
    end;
  end;
  Close(ft);
end;
//---------------------------------------------
function     TDict.Incr ( const s:string ):boolean; //  ,   
var i: integer;
begin
  if Find( s, i) then begin Incr:=True; TInt(objects[i]).incr; end
  else                      Incr:=False;
end;
//---------------------------------------------
function     TDict.Incr2( const s:string ):boolean; //    
var i: integer;
begin
  if  Find( s, i) then begin Incr2:=True; TInt(objects[i]).incr; end
  else                 begin Incr2:=False; AddObject( s, TInt.Create(1));  end;
end;
//---------------------------------------------
Function FirstWord( var s: string ): string;{      }
var p, l: integer;
begin
  s := Trim(s);
  l := length(s);
  if l=0 then begin FirstWord := ''; Exit end;
  p := pos( ' ', s);
  if p = 0 then p:=l+1;
  FirstWord := copy( s, 1, p-1 );
  s := copy(s, p, l );
end;
//-------------------------------------------------------------------
Function   ReadWord( var f: text ): string; //      
var i, j, l: integer;
    ch: char;
begin
  while ReadWordBuf = '' do begin
    if eof( f ) then begin ReadWord := ''; Exit; end;
    ReadLn( f, ReadWordBuf ); inc(NReadLines);
    ReadWordBuf := lastword+Trim( ReadWordBuf );
    l  := length( ReadWordBuf );
    if l>0 then begin
      ch := ReadWordBuf[l]; //    
      for i:= 1 to l do ReadWordBuf[i] := RusUpp( ReadWordBuf[i] );
      if (l>8) and (ch='-')and (ReadWordBuf[l-1]<>' ') then begin //    - 
        j:=l-1; while (j>0) and (ReadWordBuf[j]<>' ') do dec(j);
        lastword := Trim(copy( ReadWordBuf, j+1, l-j+1 ));
        Delete( ReadWordBuf, j, l );
      end else lastword := '';
      ReadWordBuf := Trim( ReadWordBuf );
    end;
  end;
  //  ReadWordBuf  
  ReadWord := FirstWord(ReadWordBuf)
end;
//----------------------------------------------------------------------
var dt, dtNew: TDict;
procedure OneFile( fn:string );
var
    ft: text;
    i, cou: integer;
    s: string;
begin
  is866 := Check866( fn );
{$I-}
  AssignFile( ft, fn ); Reset(ft);
  if IOResult <> 0 then begin
    WriteLn('File '+fn+' not found');
    Exit;
  end;
{$I+}
  //if FileSize(ft) < 256 then Exit;
  cou:=0;
  while (not eof(ft)) or (ReadWordBuf<>'') do begin
    s := ReadWord( ft );
    if pos('-',s)>0 then continue;
    if length(s)<4 then continue;
    //    
    {     dtnew:
    for i:= 5 to length(s) do dt.Incr( copy(s,1,i) );
    if not dt.Incr( copy(s,1,4) ) then begin
      for i:=4 to length(s) do dtnew.Incr2( copy(s,1,i) );
    end;
    }
    {     dtnew: }
    for i:= 4 to length(s) do dt.Incr( copy(s,1,i) );
    if (cou mod 10000)=0 then
    write( 'file:', fn:15, ';  ReadLines=', NReadLines:6, ' words=', cou:8, ' len(dtNew)=', dtnew.count:8, #13 );
    inc(cou);
  end;
  WriteLn;
end;
//---------------------------------------------
var i : integer;
    sr: TSearchRec;
begin
  if ParamCount = 0 then Help('Illegal arguments number');
  dt := TDict.Create;
  dt.LoadFromFile('RUS_WORD.ORG');

  dtNew := TDict.Create;
  dtnEW.LoadFromFile('RUS_NEW.ORG');
  dtNew.Sorted := True;

  if ParamStr(1) = '0' then begin //    -  
    for i:=0 to dt.count-1    do dt.objects   [i] := TInt.Create(0);
    for i:=0 to dtNew.count-1 do dtNew.objects[i] := TInt.Create(0);

    dt.SaveToFileF   ('RUS_WORD.ORG', 0);
    dtnEW.SaveToFileF('RUS_NEW.ORG', 0);
    Halt;
  end;
  //   ,   .
  for i:= 1 to ParamCount do begin
    if FindFirst( ParamStr(i), faAnyFile, sr)=0 then begin
      OneFile( sr.Name );
      while FindNext(sr) = 0 do OneFile( sr.Name );
    end;
  end;
  FindClose(sr);
  dt.SaveToFileF('RUS_WORD.ORG', 0);
  dtnew.SaveToFileF('RUS_NEW.ORG', 3);
end.

