program dict2; //  
{$APPTYPE    CONSOLE}
uses Sysutils, Classes;

procedure Help(const s: string );
begin
  WriteLn('Work with numbero of dictionaries.');
  WriteLn( s );
  Halt;
end;
//---------------------------------------------
var w   : TStringList;                // 
    f   : array of array of integer;  // 
    names: array of string[8];        //  
    nw, nd : integer; // # , 
//---------------------------------------------
procedure NormColumns; //    = 1e9
var iw, id: integer;
    co : extended;
begin
  for id:= 0 to nd-1 do begin
    co:=0; for iw:= 0 to nw-1 do co:=co+sqr(0.0+f[iw,id]);
    if co = 0 then continue;  //    0
    co := 1e6/sqrt(co);
    for iw:= 0 to nw-1 do  f[iw,id] := round( co*f[iw,id]);
  end;
end;
//---------------------
procedure NormLines;
var iw, id: integer;
    co : extended;
begin
  for iw:= 0 to nw-1 do begin
    co:=0; for id:= 0 to nd-1 do co:=co+sqr(0.0+f[iw,id]);
    if co = 0 then continue;  //    0
    co:= 1.0e6*sqrt(nd/nw/co);
    for id:= 0 to nd-1 do  f[iw,id] := round( co*f[iw,id]);
  end;
end;
//---------------------------------------------
procedure SaveTo( fn: string );
var iw, id: integer;
    ft : TextFile;
    s: string[16];
begin
  WriteLn( 'Save to ', fn );
  AssignFile( ft, fn ); Rewrite(ft);
  Write( ft, ' :    ':16);
  for id:= 0 to nd-1 do Write( ft, trim(names[id]):9 );
  WriteLn(ft);
  for iw:= 0 to nw-1 do begin
    s := w.strings[iw]+'                 ';
    Write(ft, s);
    for id:= 0 to nd-1 do Write( ft, f[iw,id]:9 );
    WriteLn(ft);
  end;
  CloseFile(ft);
end;
//---------------------------------------------
procedure OneFileLoad( fn:string );
var i, v, code : integer;
    ft : text;
    s  : string;
begin
  WriteLn( 'Loading dict ', fn, ' ...' );
  if w.Count = 0 then begin //  
    w.LoadFromFile(fn);     //   
    nw := w.Count;
    for i:=0 to nw-1 do begin
      w.strings[i] := Trim(Copy( w.strings[i], 1, 16 ));
    end;
    SetLength( f, nw, 10);
    SetLength( names, 10);
    nd := 0;                //    
  end;
  //     
  //  ,  
  if nd >= Length(f[0] ) then begin
    SetLength( f, nw, nd+10);
    SetLength( names, nd+10);
  end;
  names[nd] := ChangeFileExt(fn,'')+'           ';
  AssignFile( ft, fn ); Reset(ft);
  i:=0;
  while (not eof(ft)) and (i<nw) do begin
    ReadLn( ft, s);
    Val( copy(s,17, 12), v, code );
    f[i, nd] := v;
    if code > 0 then Help('Illegal string in file '+fn+' string # '+IntToStr(i) );
    inc(i);
  end;
  CloseFile(ft);
  // f[*,nd] -    .
  inc(nd);  //   
end;
//---------------------------------------------
var i: integer;
    sr: TSearchRec;
begin
  w := TStringList.Create;
  nd:= 0;
  //   ,   .
  for i:= 1 to ParamCount do begin
    if FindFirst( ParamStr(i), faAnyFile, sr)=0 then begin
      OneFileLoad( sr.Name );
      while FindNext(sr) = 0 do OneFileLoad( sr.Name );
    end;
  end;
  FindClose(sr);
  //   
  NormColumns; // SaveTo( 'all1.org' );
  NormLines; NormColumns;   SaveTo( 'all.org' );
end.

