program dict3; //  
{$APPTYPE    CONSOLE}
uses Sysutils, Classes;

type
  TInt  = class(TObject)
    f: integer;
    constructor Create( v:integer );
    procedure   Incr;
  end;

  TDict = class(TStringList)
    procedure   LoadFromFile(const FileName: string); override;
    function    Incr ( const s: string ):boolean; //   ,   
    function    Incr2( const s: string ):boolean; //   ,  
    procedure   SaveToFileF(const FileName: string; fr0: integer);
  end;
//---------------------------------------------
var ReadWordBuf, lastword: string;
    NReadLines: integer;
    is866     : boolean; //     866 ?

    f      : array of array of integer; // 
    names  : array of string[8];        //  
    nw, nd : integer;                   // # , 
    scalp  : array of extended;         //  
    res    : TextFile;                  // 
    d_norm : extended;                  //  
const Delta_w = 50000;                  //     
//---------------------------------------------
Function   RusUpp( ch: char ): char; // ->     
var cb: byte;
begin
  cb := ord(ch);
  RusUpp := ' ';
  //if ch='-' then rusupp:='-';
  if is866 then begin
    if (cb >= 128) and (cb<=159) then RusUpp := char(cb+64);
    if (cb >= 160) and (cb<=175) then RusUpp := char(cb+32);
    if (cb >= 224) and (cb<=239) then RusUpp := char(cb-16);
  end else begin
    if ( ch>='')and ( ch<='')then RusUpp:=ch;
    if ( ch>='')and ( ch<='')then RusUpp:=char( ord( ch)-ord('')+ord(''));
  end;
end;
//---------------------------------------------
procedure Help(const s: string );
begin
  WriteLn('Work with dictionaries.');
  WriteLn('dict 0          - clear frequences in RUS_WORD.ORG and RUS_NEW.ORG');
  WriteLn('dict FILEMASKS  - increase frequences if RUS_WORD.ORG and RUS_NEW.ORG');
  WriteLn('                  from files FILEMASK');
  WriteLn('!!Files of length < 256 ignored');
  WriteLn;
  WriteLn( s );
  Halt;
end;
//---------------------------------------------
function MaxIndex( a: array of extended ): integer;
var i, mi: integer;
    ma   : extended;
begin
  mi:= -1; ma:= -1e-4000;
  for i:=0 to High(a) do
  if a[i]>ma then begin mi:=i; ma:=a[i]; end;
  MaxIndex := mi;
end;
//----   866 ?
function  Check866( fn: string ): boolean;
const bsize = 4096;
var ft: file;
    buf: array[1..bsize] of byte;
    fre: array[128..255] of integer; //  
    i, NumRead: integer;
    pd, pdn, pw, pwn : integer;
  // - - -   
  function su( i1, i2: integer ): integer;
  var i,s: integer;
  begin
     s := 0;
     for i:=i1 to i2 do s:=s+fre[i];
     su := s;
  end;
  //   Check866
begin
  AssignFile( ft, fn ); Reset(ft,1);
  BlockRead( ft, buf, bsize, NumRead);
  for i:=128 to 255 do fre[i] := 0;
  for i:=1 to NumRead do if buf[i]>=128 then inc(fre[buf[i]]);
  CloseFile( ft );
  pd := su( 128, 175 ) + su( 224, 239 );
  pdn:= su( 176, 223 ) + su( 240, 255 );
  pw := su( 192, 255 );
  pwn:= su( 128, 191 );
  if pd*pwn > pw*pdn then Check866 := True else Check866 := False;
end;
//---------------------------------------------
constructor TInt.Create( v:integer );
begin
  f:=v;
end;
//---------------------------------------------
procedure TInt.Incr; begin Inc(f); end;
//---------------------------------------------
procedure   TDict.LoadFromFile(const FileName: string);
var i, p, fr, code, cnt:integer;
    s, sb, slast:string;
    addi: integer;
    ft : TextFile;
begin
  Sorted     := True;
  Duplicates := dupIgnore;
  if not FileExists(FileName) then Exit;

  // inherited LoadFromFile( FileName );  -   
  AssignFile( ft, FileName); Reset(ft); cnt:=0;
  while not eof(ft) do begin
    ReadLn( ft, s); s:=Trim(s); inc(cnt);
    if (cnt mod 1000) = 0 then Write( cnt:9, #13 );
    if length(s)<4 then continue;
    p := pos( ' ', s );
    if p>0 then begin                                 //  
      if p < 5 then continue;                         //   4   
      val( copy(s, p+1, 40), fr, code );
      s := copy( s, 1, p-1 );
      for i:= 1 to p-1 do s[i] := RusUpp( s[i] );
      i:=Add( copy( s, 1, 16) );
      if code =0 then objects[i] := TInt.Create(fr);  //     - 
    end else begin
      for i:= 1 to length(s) do s[i] := RusUpp( s[i] );
      Add( copy( s, 1, 16) );
    end;
  end;
  CloseFile(ft);

  //.     >3
  Sorted := True;
  i:=0; addi:=0; slast := '';
  while i<count do begin
    if (i mod 10000)=0 then write( 'i=', i:6, ' size=', count:6, ' news=', addi:6, #13 );
    s := Strings[i];
    if slast <> copy(s,1,Length(s)-1) then begin
      for p:=4 to Length(s)-1 do begin
        sb := copy(s,1,p);
        if not Find( sb, code) then begin
          AddObject( sb, TInt.Create(0));
          inc(addi);
        end;
      end;
    end;
    slast := s;
    inc(i);
  end;
end;
//---------------------------------------------
procedure   TDict.SaveToFileF(const FileName: string; fr0: integer);
var ft: TextFile;
    i, fr: integer;
    s: string[16];
begin
{$I-}
  AssignFile( ft, FileName); Rewrite(ft); if IOResult <> 0 then Exit;
{$I+}
  for i:= 0 to count-1 do begin
    fr := TInt(objects[i]).f;
    if fr>=fr0 then begin
      s := strings[i]+'                 ';
      WriteLn( ft, s, TInt(objects[i]).f:9);
    end;
  end;
  Close(ft);
end;
//---------------------------------------------
function     TDict.Incr ( const s:string ):boolean; //  ,   
var i: integer;
begin
  if Find( s, i) then begin Incr:=True; TInt(objects[i]).incr; end
  else                      Incr:=False;
end;
//---------------------------------------------
function     TDict.Incr2( const s:string ):boolean; //    
var i: integer;
begin
  if  Find( s, i) then begin Incr2:=True; TInt(objects[i]).incr; end
  else                 begin Incr2:=False; AddObject( s, TInt.Create(1));  end;
end;
//---------------------------------------------
Function FirstWord( var s: string ): string;{      }
var p, l: integer;
begin
  s := Trim(s);
  l := length(s);
  if l=0 then begin FirstWord := ''; Exit end;
  p := pos( ' ', s);
  if p = 0 then p:=l+1;
  FirstWord := copy( s, 1, p-1 );
  s := copy(s, p, l );
end;
//-------------------------------------------------------------------
Function   ReadWord( var f: text ): string; //      
var i, j, l: integer;
    ch: char;
begin
  while ReadWordBuf = '' do begin
    if eof( f ) then begin ReadWord := ''; Exit; end;
    ReadLn( f, ReadWordBuf ); inc(NReadLines);
    ReadWordBuf := lastword+Trim( ReadWordBuf );
    l  := length( ReadWordBuf );
    if l>0 then begin
      ch := ReadWordBuf[l]; //    
      for i:= 1 to l do ReadWordBuf[i] := RusUpp( ReadWordBuf[i] );
      if (l>8) and (ch='-')and (ReadWordBuf[l-1]<>' ') then begin //    - 
        j:=l-1; while (j>0) and (ReadWordBuf[j]<>' ') do dec(j);
        lastword := Trim(copy( ReadWordBuf, j+1, l-j+1 ));
        Delete( ReadWordBuf, j, l );
      end else lastword := '';
      ReadWordBuf := Trim( ReadWordBuf );
    end;
  end;
  //  ReadWordBuf  
  ReadWord := FirstWord(ReadWordBuf)
end;
//----------------------------------------------------------------------
var dt: TDict;
procedure OneFile( fn:string );
var
    ft            : text;
    i, cou, iw, id: integer;
    s             : string;
    co, sz1       : extended;
    i1, i2, i3    : integer;
    m1, m2, m3    : extended;
begin
  is866 := Check866( fn );
{.$I-}
  AssignFile( ft, fn ); Reset(ft);
  if IOResult <> 0 then begin
    WriteLn('File '+fn+' not found');
    Exit;
  end;
{.$I+}
  //if FileSize(ft) < 256 then Exit;
  cou:=0; ReadWordBuf := '';
  for i:=0 to dt.count-1 do dt.objects[i] := TInt.Create(0);
  while (not eof(ft)) or (ReadWordBuf<>'') do begin
    s := ReadWord( ft );
    if pos('-',s)>0 then continue;
    if length(s)<4 then continue;
    //    
    for i:= 4 to length(s) do dt.Incr( copy(s,1,i) );
    if (cou mod 10000)=0 then
    write( 'file:', fn:15, ';  ReadLines=', NReadLines:6, ' words=', cou:8, #13 );
    inc(cou);
  end;
  CloseFile( ft );
  WriteLn;
  //  .     
  sz1 := 0;
  for iw:= 0 to nw-1 do sz1 := sz1 + sqr(0.0+TInt(dt.objects[iw]).f);
  sz1 := sqrt(sz1);
  for id:= 0 to nd-1 do begin
    co := 0;
    for iw:= 0 to nw-1 do co := co + (0.0+TInt(dt.objects[iw]).f)*f[iw, id];
    co := co/ (d_norm*sz1);
    scalp[id] := co;
  end;
  i1 := MaxIndex(scalp); m1 := scalp[i1]; scalp[i1]:= 0;
  i2 := MaxIndex(scalp); m2 := scalp[i2]; scalp[i2]:= 0;
  i3 := MaxIndex(scalp); m3 := scalp[i3]; scalp[i3]:= 0;
  scalp[i1] := m1;
  scalp[i2] := m2;
  scalp[i3] := m3;
  Write( res, fn:16, ' ');
  Write( res, names[i1]:9, '(', 1000*m1:9:1, '); ' );
  Write( res, names[i2]:9, '(', 1000*m2:9:1, '); ' );
  Write( res, names[i3]:9, '(', 1000*m3:9:1, '); ' );

  Write(      fn:16, ' ');
  Write(      names[i1]:9, '(', 1000*m1:9:1, '); ' );
  Write(      names[i2]:9, '(', 1000*m2:9:1, '); ' );
  Write(      names[i3]:9, '(', 1000*m3:9:1, '); ' );

  for id:= 0 to nd-1 do Write( res, 1000*scalp[id]:9:1 );
  WriteLn(res);
  Flush(res);
  WriteLn;
end;
//---------------------------------------------
var i, id, iw : integer;
    sr        : TSearchRec;
    ft        : TextFile;
    s         : string;
    s16       : string[16];
    co        : extended;
begin
  if ParamCount = 0 then Help('Illegal arguments number');
  dt := TDict.Create;
  dt.Sorted     := True;
  dt.Duplicates := dupIgnore;
  //     
  AssignFile( ft, 'all.org' ); Reset(ft);
  ReadLn( ft, s );  //  :      ACTION    ACTS ...
  s := Trim(copy( s, 16, length(s) ));
  SetLength( names, 10);
  nd := 0;
  while s <> '' do begin
    if nd >= Length( names ) then SetLength( names, nd+10);
    names[nd] := FirstWord(s);
    inc(nd);
  end;
  //   names[0..(nd-1)]    
  SetLength( scalp, nd );
  SetLength( f, Delta_w, nd ); nw := 0;
  while not eof(ft) do begin
    if nw >= Length(f) then SetLength( f, nw+Delta_w, nd);
    Read( ft, s16);
    //dt.Add( Trim(s16) );
    dt.AddObject( Trim(s16), TInt.Create(0));
    for id:=0 to nd-1 do Read( ft, f[nw,id]);
    ReadLn( ft );
    inc(nw);
    if (nw mod 10000) = 0 then Write( 'Read all.org', (nw div 1000):6, #13);
  end;
  CloseFile(ft);
  //   f[0..(nw-1), 0..(nd-1)]     
  // dt -    
  for id:= 0 to nd-1 do begin
    co := 0;
    for iw:= 0 to nw-1 do co := co + sqr(0.0+f[iw, id]);
    d_norm := sqrt(co);   //  
  end;


  AssignFile( res, 'result.res' ); Rewrite(res);  // 
  Write( res,'Items:                                                                             ' );
  for id:= 0 to nd-1 do Write( res, names[id]:9 );
  WriteLn( res );
  //   ,   .
  for i:= 1 to ParamCount do begin
    if FindFirst( ParamStr(i), faAnyFile, sr)=0 then begin
      OneFile( sr.Name );
      while FindNext(sr) = 0 do OneFile( sr.Name );
    end;
  end;
  FindClose(sr);
  CloseFile(res);
end.

